#pragma once

#include <Engine/Base/Lists.h>
#include <Engine/Base/CTString.h>

// sub-driver type for OpenGL driver
enum OpenGLDriverType {
  ODT_NONE = -1,   // no driver
  ODT_ICD  =  0,   // default driver
  ODT_3DFX =  1,   // voodoo driver
};

// display mode bit-depth
enum DisplayDepth {
  DD_DEFAULT=0,
  DD_16BIT=1,
  DD_32BIT=2,
};

/*
 *  Structure that holds display mode description
 */

class ENGINE_API CDisplayMode {
public:
  CListNode dm_Node; // for linking in list of avaliable modes
  PIX   dm_pixSizeI; // size of screen in pixels
  PIX   dm_pixSizeJ;
  enum DisplayDepth dm_ddDepth;  // bits per pixel

  /* Default constructor. */
  CDisplayMode(void);

  // get depth string
  CTString DepthString(void) const;
  // check if mode is dualhead
  BOOL IsDualHead(void);
  // check if mode is widescreen
  BOOL IsWideScreen(void);
  // check if mode is fullscreen
  BOOL IsFullScreen(void);
};
