#pragma once

#include <Engine/Graphics/Raster.h>

/*
 *  ViewPort
 */

class CTempDC {
public:
  HDC hdc;
  HWND hwnd;
  CTempDC(HWND hWnd);
  ~CTempDC(void);
};

// base abstract class for viewport
class ENGINE_API CViewPort {
public:
// implementation
  INDEX vp_ctDisplayChanges;    // number of display driver
  HWND vp_hWnd;                 // temporary child window
  HWND vp_hWndParent;           // window of the viewport
  CRaster vp_Raster;            // the used Raster

  // open temporary window
  void OpenChildWindow(void);
  // close temporary window
  void CloseChildWindow(void);

// interface
  /* Constructor for given window. */
  CViewPort(PIX pixWidth, PIX pixHeight, HWND hWnd);
	/* Destructor. */
  ~CViewPort(void);

	/* Display the back buffer on screen. */
  void SwapBuffers(void);
  // change size of this viewport, it's raster and all it's drawports to fit it window
  void Resize(void);
};
